﻿using System;
using System.Data;
using System.Linq;

using Oracle.ManagedDataAccess.Client;

using Dapper;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            string connectionString = @"Data Source=(DESCRIPTION = (ADDRESS_LIST = (ADDRESS = (PROTOCOL = TCP)(HOST = 127.0.0.1)(PORT = 1521)))(CONNECT_DATA = (SERVICE_NAME = orcl)));User ID=SYSTEM;Password=P@ssw0rd";

            using(OracleConnection connection = new OracleConnection(connectionString))
            {
                OracleDynamicParameters parameters = new OracleDynamicParameters();

                parameters.Add("I_NAME"  , "S");
                parameters.Add("O_CURSOR", OracleDbType.RefCursor, ParameterDirection.Output);

                var resultList = connection.Query<dynamic>
                (
                    "SCOTT.GETMEMBERLIST",
                    param : parameters,
                    commandType : CommandType.StoredProcedure
                )
                .ToList();

                foreach(var item in resultList)
                {
                    Console.WriteLine(item.ENAME);
                }
            }
        }

        #endregion
    }
}